#include <bits/stdc++.h>
using namespace std;
#define int long long
#define double long double
#define f first
#define s second
string s1[54],s2[54];
int r,c,dist[54][54];
bool vis[54][54];
vector<pair<pair<int,int>,pair<int,int>>> moves;
bool neigh (int x, int y) {
    if (x>0 && s1[x-1][y]=='*')
        return true;
    if (y>0 && s1[x][y-1]=='*')
        return true;
    if (x<(r-1) && s1[x+1][y]=='*')
        return true;
    if (y<(c-1) && s1[x][y+1]=='*')
        return true;
    return false;
}

void find(){
    cin>>r>>c;
    for (int i=0;i<r;i++)
        cin>>s1[i];
    for (int i=0;i<r;i++)
        cin>>s2[i];
    for (int i=0;i<r;i++)
        for (int j=0;j<c;j++)
            dist[i][j]=10001;

    for (int i=0;i<r;i++)
        for (int j=0;j<c;j++)
        {
            if (s2[i][j] == '*') {
//                for (int h = 0; h < r; h++)
//                    for (int k = 0; k < c; k++)
//                        vis[h][k] = false || (s1[h][k] == 'X');
//                g(i, j, 0);

                queue<pair<int,int>> q;
                q.push({i,j});
                dist[i][j]=0;
                while (!q.empty()) {
                    int x = q.front().first;
                    int y = q.front().second;
                    q.pop();
                    int new_d=dist[x][y]+1;
                    if (y<(c-1) && s1[x][y+1]!='X') {
                        if (dist[x][y+1] > new_d) {
                            dist[x][y+1]=new_d;
                            q.push({x,y+1});
                        }
                    }
                    if (x<(r-1) && s1[x+1][y]!='X') {
                        if (dist[x+1][y] > new_d) {
                            dist[x+1][y]=new_d;
                            q.push({x+1,y});
                        }
                    }
                    if (y>0 && s1[x][y-1]!='X') {
                        if (dist[x][y-1] > new_d) {
                            dist[x][y-1]=new_d;
                            q.push({x,y-1});
                        }
                    }
                    if (x>0 && s1[x-1][y]!='X') {
                        if (dist[x - 1][y] > new_d) {
                            dist[x - 1][y] = new_d;
                            q.push({x - 1, y});
                        }
                    }
                }
            }
        }

    bool ok=true;
    int total_dist = 0;
    for (int i=0;i<r;i++)
        for (int j=0;j<c;j++) {
            if (s1[i][j]=='*') {
                if (dist[i][j]>10000)
                    ok=false;
                total_dist += dist[i][j];
            }
        }
    if (!ok) {
        cout<<"NO";
        return;
    }
    int nr=0;
    while (nr<10000 && total_dist>0) {
        int pos1x=0;
        int pos1y=0;
        int pos2x=0;
        int pos2y=0;
        int prev_dist = total_dist;
        int max_dist=0;
        int min_dist=10001;

        for (int i=0;i<r;i++)
            for (int j=0;j<c;j++)
                if (s1[i][j]=='*') {
                    if (dist[i][j]>max_dist) {
                        max_dist=dist[i][j];
                        pos1x=i;
                        pos1y=j;
                    }
                }
        for (int i=0;i<r;i++)
            for (int j=0;j<c;j++) {
                if (s1[i][j]=='.' && neigh(i,j)) {
                    if (dist[i][j]<min_dist) {
                        min_dist=dist[i][j];
                        pos2x=i;
                        pos2y=j;
                    }
                }
            }
        s1[pos1x][pos1y]='.';
        s1[pos2x][pos2y]='*';
        total_dist -= (max_dist - min_dist);
        assert(total_dist<prev_dist);
        moves.push_back({{pos1x + 1, pos1y + 1}, {pos2x + 1, pos2y + 1}});
        nr++;
    }
    assert(total_dist>=0);
    if (total_dist==0) {
        cout<<"YES"<<'\n';
        cout<<nr<<"\n";
        for (int i=0;i<nr;i++) {
            cout<<moves[i].first.first<<" "<<moves[i].first.second<<" "<<moves[i].second.first<<" "<<moves[i].second.second<<'\n';
        }
    } else {
        cout<<"NO";
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        find();
    }
    return 0;
}